#include<bits/stdc++.h>
using namespace std;
int main(){
    int t;
    cin>>t;
    int n;
    string dane[t];
    for(int j=0;j<t;j++){
        cin>>n;
        int a[n];  int b[n];
        int br1=0; int br2=0;
        int achos; int bchos;
        int poza;  int pozb;
        for(int i=0;i<n;i++){
            cin>>a[i];
            if(a[i]!=0){
                br1++;
                achos=a[i];
                poza=i;
            }
        }
        for(int i=0;i<n;i++){
            cin>>b[i];
            if(b[i]!=0){
                br2++;
                bchos=b[i];
                pozb=i;
            }
        }
        if(br1==1 && br2==1){
            if(achos==bchos){
                if((poza-pozb)%2==0) dane[j]="DA";
                if((poza-pozb)%2==1) dane[j]="NE";
            } else {
                if(achos==-bchos){
                    if((poza-pozb)%2==0) dane[j]="NE";
                    if((poza-pozb)%2==1) dane[j]="DA";
                } else {
                    dane[j]="NE";
                }
            }
        } else {
            for(int i=0;i<n;i++){
                if(i==n-1){
                    if(a[n-1]==b[n-1]){
                        dane[j]="DA";
                    } else {
                        dane[j]="NE";
                    }
                } else {
                    if(a[i]!=b[i] && a[i]!=a[i+1]){
                        dane[j]="NE"; i=n;
                    } else {
                        if(a[i]!=b[i] && a[i]==a[i+1]){
                            a[i]=-a[i];
                            a[i+1]=-a[i+1];
                        }
                    }
                }
            }
        }
    }
    for(int i=0;i<t;i++){
        cout<<dane[i]<<endl;
    }
}